from os import PathLike
from configparser import RawConfigParser
from sqlcycli._ssl import SSL

# Custom Parser -------------------------------------------------------------------------------
class ConfigParser(RawConfigParser): ...

# MysqlOption ---------------------------------------------------------------------------------
class OptionFile:
    def __init__(
        self,
        opt_file: str | bytes | PathLike,
        opt_group: str = "client",
    ) -> None: ...

    # Property --------------------------------------------------------------------------------
    @property
    def opt_file(self) -> str | bytes | PathLike: ...
    @property
    def opt_group(self) -> str: ...
    @property
    def host(self) -> str | None: ...
    @property
    def port(self) -> int | None: ...
    @property
    def user(self) -> str | None: ...
    @property
    def password(self) -> str | None: ...
    @property
    def database(self) -> str | None: ...
    @property
    def charset(self) -> str | None: ...
    @property
    def bind_address(self) -> str | None: ...
    @property
    def unix_socket(self) -> str | None: ...
    @property
    def max_allowed_packet(self) -> str | None: ...
    @property
    def ssl(self) -> SSL | None: ...
    # Special Methods -------------------------------------------------------------------------
    def __repr__(self) -> str: ...
